##Load shared libraries
dyn.load("cRMaternOMPWrong.so")
source("cRMaternOMPWrong.R")

dyn.load("cRMaternOMPSafe.so")
source("cRMaternOMPSafe.R")

##Calculate Euclidean distance matrix then spatial correlation
n <- 100

set.seed(1)
coords <- cbind(runif(n,0,1), runif(n,0,1))
D <- as.matrix(dist(coords))

##Sequential
R <- c.R.matern.omp.wrong(D, phi=6, nu=1, n.omp.threads=1)$R
chol.sqrt <- chol(R)

##Parallel (not thread-safe)
R <- c.R.matern.omp.wrong(D, phi=6, nu=1, n.omp.threads=1)$R
chol.sqrt <- chol(R)

##Parallel (thread-safe)
R <- c.R.matern.omp.safe(D, phi=6, nu=1, n.omp.threads=4)$R
chol.sqrt <- chol(R)
